package lab.game;

import java.io.Serial;
import java.io.Serializable;

import javafx.scene.canvas.GraphicsContext;

public abstract class WorldEntity implements DrawableSimulable, Serializable {

	@Serial
	private static final long serialVersionUID = -8041266267302181620L;
	
	protected final transient World world;
	protected MyPoint position;

	protected WorldEntity(World world, MyPoint position) {
		this.world = world;
		this.position = position;
	}

	@Override
	public final void draw(GraphicsContext gc) {
		gc.save();
		drawInternal(gc);
		gc.restore();
	}

	public abstract void drawInternal(GraphicsContext gc);

	public MyPoint getPosition() {
		return position;
	}

}
