package jez04.structure.test;

import static org.hamcrest.MatcherAssert.assertThat;

import java.net.URISyntaxException;

import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvSource;

import cz.vsb.fei.kelvin.unittest.StructureHelper;
import cz.vsb.fei.kelvin.unittest.TextFileContains;

class ClassStructureTest {

	StructureHelper helper = StructureHelper.getInstance(ClassStructureTest.class);

	// @formatter:off
	@ParameterizedTest
	@CsvSource({
			"Bullet.java,serialVersionUID",
			"Bullet.java,@Serial",
			"BulletAnimated.java,serialVersionUID",
			"BulletAnimated.java,@Serial",
			"Cannon.java,serialVersionUID",
			"Cannon.java,@Serial",
			"Ufo.java,serialVersionUID",
			"Ufo.java,@Serial",
			"MyPoint.java,serialVersionUID",
			"MyPoint.java,@Serial",
			"WorldEntity.java,serialVersionUID",
			"WorldEntity.java,@Serial",

			"WorldEntity.java,transient",
			"BulletAnimated.java,transient",
			
			"World.java,new ServerSocket",
			"World.java,Socket",
			"World.java,accept",
			"World.java,ObjectOutputStream",
			"World.java,writeObject",
			"World.java,new Socket",
			"World.java,ObjectInputStream",
			"World.java,ObjectInputStream",
			"World.java,synchronized",
		})
	// @formatter:on
	void anotaceTest(String file, String annotation) throws URISyntaxException {
		assertThat(TextFileContains.getProjectRoot(getClass()), new TextFileContains(file, annotation));
	}


}
